function error(message, skipLog) {                                        // send error message
  if (!skipLog)
    appendLog(message, 'color:red;font-weight:bold;', "error");
  if (errorMode) {
    dialogOpen = true;
    window.openDialog("chrome://fireftp/content/alert.xul","alert",
      "width=400,height=200,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", message);
    dialogOpen = false;
  }
}
function detailedError(msg, url, linenumber) {
  if (debugMode && linenumber)
    error('Error message= ' + msg + '\nURL= ' + url + '\nLine Number= ' + linenumber, false);
}
function debug(message, errornum, level) {                                // add debug message to log; last error number is currently 42
  var type = level ? level : "Error";
  if (debugMode)
    appendLog(type + " " + errornum + ": " + message, 'color:red;font-weight:bold;', "debug");
}
function sendAbort() {
  isReconnecting = false;
  if (suppressQueue)
    isReady = true;
  suppressQueue = false;
  progressEventSink.bytesTotal = 0;                                       // stop uploads
  dataListener.bytesTotal = 0;                                            // stop downloads
  eventQueue = new Array;
  trashQueue = new Array;
  pauseTrashQueue = new Array;
  pauseEventQueue = new Array;

  if (!isConnected)
    return;
  //XXX writeControl("ABOR");                                             // see note below

  killDataSocket();                                                       // ABOR does not seem to stop the connection in most cases
                                                                          // so this is a more direct approach

  addEventQueue("aborted");
  
  localTree.refresh();
  remoteTree.refresh();
}
function recoverFromDisaster() {                                          // after connection lost, try to restart queue
  if (eventQueue.length && eventQueue[0].cmd == "goodbye")
    eventQueue.shift();
  if (eventQueue.cmd)
    eventQueue = new Array(eventQueue);
  if (eventQueue.length && (eventQueue[0].cmd == "LIST" || eventQueue[0].cmd == "LIST2"
      || eventQueue[0].cmd == "RETR" || eventQueue[0].cmd == "RETR2"
      || eventQueue[0].cmd == "REST" || eventQueue[0].cmd == "APPE"
      || eventQueue[0].cmd == "STOR" || eventQueue[0].cmd == "STOR2"
      || eventQueue[0].cmd == "PASV" || eventQueue[0].cmd == "APPE2")) {
    var cmd = eventQueue[0].cmd;
    var parameter = eventQueue[0].parameter;
    if (cmd == "LIST2" || cmd == "RETR2" || cmd == "STOR2" || cmd == "APPE2")
      eventQueue[0].cmd = eventQueue[0].cmd.substring(0,4);
    cmd = eventQueue[0].cmd;

    if (cmd == "REST") {                                                  // set up resuming for these poor interrupted transfers
      try {
        var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(eventQueue[1].remember);
        if (file.fileSize)
          eventQueue[0].parameter = file.fileSize;
      } catch(ex) { debug(ex,39); }
    } else if (cmd == "RETR") {
      try {
        var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(eventQueue[0].remember);
        if (file.fileSize)
          unshiftEventQueue("REST", file.fileSize, "");
      } catch(ex) { debug(ex,40); }
    }

    for (var x = trashQueue.length - 1; x >= 0; --x)                      // take cmds out of the trash and put them back in the eventQueue
      eventQueue.unshift(trashQueue[x]);

    if (cmd == "STOR" || cmd == "APPE")                                   // more resuming fun - this time for the stor/appe commandds
      unshiftEventQueue("SIZE", parameter, cmd);
  } else if (eventQueue.length && eventQueue[0].cmd == "RNTO") {          // don't worry RNTO, i didn't forget about you :)
    if (trashQueue[trashQueue.length - 1].cmd == "RNFR")
      eventQueue.unshift(trashQueue[trashQueue.length - 1]);              // ah, that's better
  }
  trashQueue = new Array;
}
function checkTimeout(id, cmd, dataSocket) {                              // uploads currently can't be used with this function - we ignore them
  if (dialogOpen) {
    setTimeout("checkTimeout(" + id + ",'" + cmd + "', " + dataSocket + ")", retry * 1000);
    return;
  }
  if (networkTimeoutID == id && eventQueue.length && (dataSocket || eventQueue[0].cmd.indexOf(cmd) != -1)) { // still stuck on a command
    legitClose = false;                                                   // trying to restart the connection after a timeout
    close();                                                              // try to restart the connection the hard way
  }
}
