function transfer(download, aFile, lp, rp, pp, sa) {        // these variables correspond to the ones below - localParent, remoteParent, prompt, skipAll
  if (!isConnected || (download && !aFile && remoteTree.selection.count == 0) || (!download && !aFile && localTree.selection.count == 0))
    return;

  var prompt = lp ? pp : true;                             // if lp isn't null we're doing a recursive call
  var skipAll = lp ? sa : false;
  var resume;
  var localParent = lp ? lp : gLocalPath.value;
  var remoteParent = lp ? rp : gRemotePath.value;
  var files = new Array();

  if (noPromptMode)                                        // overwrite dialog is disabled, do overwrites
    prompt = false;

  if (aFile)
    files.push(aFile);
  else if (download) {                                     // download specific
    if (lp)                                                // if recursive
      files = data;
    else                                                   // else
      for (var x = 0; x < remoteTree.rowCount; ++x)
        if (remoteTree.selection.isSelected(x))
          files.push(remoteTree.data[x]);
  } else {                                                 // upload specific
    if (lp) {                                              // if recursive
      try {
        var dir = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        dir.initWithPath(localParent);
        var entries = dir.directoryEntries;
        while (entries.hasMoreElements()) {
          var file = entries.getNext().QueryInterface(Components.interfaces.nsIFile);
          if (file.exists() && (!file.isHidden() || hiddenMode))
            files.push(file);
        }
      } catch (ex) {
        debug(ex,26);
        return;                                            // skip this directory
      }
    } else {                                               // else
      for (var x = 0; x < localTree.rowCount; ++x)
        if (localTree.selection.isSelected(x))
          files.push(localTree.data[x]);
    }
  }

  for (var x = 0; x < files.length; ++x) {
    var fileName = files[x].leafName;                      // special request to change filename case
    if ((download && downloadCaseMode == 1) || (!download && uploadCaseMode == 1))
      fileName = fileName.toLowerCase();
    else if ((download && downloadCaseMode == 2) || (!download && uploadCaseMode == 2))
      fileName = fileName.toUpperCase();

    var remotePath  = remoteTree.constructPath(remoteParent, download ? files[x].leafName : fileName);
    var localPath   = localTree.constructPath(localParent, download ? fileName : files[x].leafName);
    var isDirectory = download ? files[x].isDirectory : files[x].isDirectory();

    var file;
    if (download) {                                        // check to see if file exists
      file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
      file.initWithPath(localPath);
    } else {
      file = { exists: function() { return false; } };
      var remoteList = lp ? data : remoteTree.data;
      for (var y = 0; y < remoteList.length; ++y)
        if (remoteList[y].leafName == fileName) {
          file = { fileSize: remoteList[y].fileSize, leafName: fileName, exists: function() { return true; } };
          break;
        }
    }

    if (files[x].fileSize >= 4294967296) {
      error(strbundle.getString("tooBig") + " '" + files[x].leafName + "' " + strbundle.getString("tooBig2"));
      continue;
    }

    if (file.exists() && skipAll)
      continue;

    resume = false;
    if (file.exists() && prompt && !isDirectory) {         // ask nicely if file exists
      resume = file.fileSize < files[x].fileSize;
      
      var params = { response         : 0,
                     fileName         : fileName,
                     resume           : true,
                     replaceResume    : !resume,
                     timerEnable      : !destructMode };

      dialogOpen = true;
      window.openDialog("chrome://fireftp/content/confirmFile.xul","confirmFile",
        "width=425,height=90,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", params);
      dialogOpen = false;

      if (params.response == 1)
        resume = false;
      else if (params.response == 2) {
        prompt = false;
        resume = false;
      } else if ((params.response == 3) || (params.response == 0))
        continue;
      else if (resume && params.response == 4)
        resume = true;
      else if (!resume && params.response == 4)
        break;
      else if (params.response == 5) {
        skipAll = true;
        continue;
      }
    }

    if (download) {
      if (isDirectory) {                                   // if the directory doesn't exist we create it
        if (!file.exists()) {
          try {
            file.create(Components.interfaces.nsILocalFile.DIRECTORY_TYPE, 0755);
          } catch (ex) {
            error(strbundle.getString("failedDir") + " '" + remotePath + "' " + strbundle.getString("failedDir2"));
            debug(ex,23);
            continue;
          }
        }

        list(remotePath, "transfer(true, '', " + localPath.toSource() + ",\'" + remotePath + "\'," + prompt + "," + skipAll + ")", false, true);
      } else {                                             // download the file
        addEventQueue("TYPE", detectAscii(remotePath));
        if (security)
          addEventQueue("PROT", "P");
        addEventQueue("PASV", "", files[x].fileSize);
        if (resume)
          addEventQueue("REST", file.fileSize);
        addEventQueue("RETR", remotePath, localPath);
      }
    } else {
      if (isDirectory) {                                   // if the directory doesn't exist we create it
        if (!file.exists()) {
          addEventQueue("MKD", remotePath);
          data = new Array();                              // we know the new directory is empty
          transfer(false, '', localPath, remotePath, prompt, skipAll);
        } else {
          removeCacheEntry();
          list(remotePath, "removeCacheEntry('" + remotePath + "');transfer(false, ''," + localPath.toSource()
              + ",\'" + remotePath + "\'," + prompt + "," + skipAll + ")", false, true);
        }
      } else {
        if (resume)
          addEventQueue("SIZE", remotePath, "APPE");       // need to do a size check
        addEventQueue("TYPE", detectAscii(remotePath));    // download the file
        if (security)
          addEventQueue("PROT", "P");
        addEventQueue("PASV");
        if (resume)
          addEventQueue("APPE", remotePath, new Array(localPath, file.fileSize));
        else
          addEventQueue("STOR", remotePath, localPath);
      }
    }
  }
  if (isReady && eventQueue.length)                        // get the ball rollin' if it isn't already
    writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
}
function detectAscii(path) {                               // detect an ascii file - returns "A" or "I"
  if (fileMode == 1)                                       // binary
    return "I";
  if (fileMode == 2)                                       // ASCII
    return "A";

  path = path.substring(path.lastIndexOf('/') + 1);        // manually detect
  path = path.substring(path.lastIndexOf('.') + 1);

  var found = false;
  for (var x = 0; x < prefAsciiFiles.length; ++x)
    if (prefAsciiFiles[x].toLowerCase() == path.toLowerCase())
      found = true;

  if (found)
    return "A";
  return "I";
}
function onChangeType() {                                  // change TYPE A/TYPE I/auto from statusbar
  var transferTypes = new Array("Auto", "Binary", "ASCII");
  fileMode = (fileMode + 1) % 3;
  document.getElementById('statustype').label = transferTypes[fileMode];
  savePreferences();
}
