var strbundle;
var programs;
function init(aEvent) {
  strbundle = document.getElementById("strings");
  programs = window.arguments[0].value;

  var found = false;
  for (var x = 0; x < programs.length; ++x) {
    if (programs[x].extension == window.arguments[0].extension.toLowerCase())
      found = true;
    document.getElementById('extensions').appendItem(programs[x].extension, programs[x].extension);
  }
  disableAll();

  if (!found && window.arguments[0].extension != "") {
    addExtension(window.arguments[0].extension.toLowerCase());
    addProgram();
  }
}
function disableAll() {
  document.getElementById('program').disabled     = true;
  document.getElementById('addp').disabled        = true;
  document.getElementById('removep').disabled     = true;
  document.getElementById('name').disabled        = true;
  document.getElementById('executable').disabled  = true;
  document.getElementById('browse').disabled      = true;
  document.getElementById('arguments').disabled   = true;
  document.getElementById('apply').disabled       = true;

  for (var x = document.getElementById('program').getRowCount() - 1; x >= 0; --x)
    document.getElementById('program').removeItemAt(x);
  document.getElementById('name').value           = "";
  document.getElementById('executable').value     = "";
  document.getElementById('arguments').value      = "";
}
function addExtension(ext) {
  var newExtension = ext ? ext : window.prompt(strbundle.getString("extension"), "", strbundle.getString("addExtension"));
  if (!newExtension || newExtension == ".")
    return;

  if (newExtension.indexOf('.') != -1)
    newExtension = newExtension.substring(newExtension.lastIndexOf('.') + 1, newExtension.length);

  newExtension = { extension: newExtension.toLowerCase(), programs: new Array() };

  // see if it's already in the list
  for (var x = 0; x < document.getElementById('extensions').getRowCount(); ++x)
    if (document.getElementById('extensions').getItemAtIndex(x).value == newExtension.extension)
      return;

  // add to list alphabetically
  for (var x = 0; x < document.getElementById('extensions').getRowCount(); ++x)
    if (document.getElementById('extensions').getItemAtIndex(x).value > newExtension.extension) {
      document.getElementById('extensions').insertItemAt(x, newExtension.extension, newExtension.extension);
      programs.splice(x, 0, newExtension);
      document.getElementById('extensions').selectedIndex = x;
      loadPrograms();
      return;
    }
  document.getElementById('extensions').appendItem(newExtension.extension, newExtension.extension);
  programs.push(newExtension);

  disableAll();

  document.getElementById('extensions').selectedIndex = document.getElementById('extensions').getRowCount() - 1;
  loadPrograms();
  document.getElementById('addp').focus();
}
function removeExtension() {
  if (!document.getElementById('extensions').selectedItem)
    return;

  var value = document.getElementById('extensions').selectedItem.value;
  if (value == "*.*")
    return;

  document.getElementById('extensions').removeItemAt(
      document.getElementById('extensions').getIndexOfItem(document.getElementById('extensions').selectedItem));

  for (var x = 0; x < programs.length; ++x)
    if (programs[x].extension == value) {
      programs.splice(x, 1);
      break;
    }

  disableAll();
}
function loadPrograms() {
  if (!document.getElementById('extensions').selectedItem)
    return;

  document.getElementById('program').disabled     = false;
  document.getElementById('addp').disabled        = false;
  document.getElementById('removep').disabled     = false;
  document.getElementById('name').disabled        = true;
  document.getElementById('executable').disabled  = true;
  document.getElementById('browse').disabled      = true;
  document.getElementById('arguments').disabled   = true;
  document.getElementById('apply').disabled       = true;
  document.getElementById('name').value           = "";
  document.getElementById('executable').value     = "";
  document.getElementById('arguments').value      = "";

  for (var x = document.getElementById('program').getRowCount() - 1; x >= 0; --x)
    document.getElementById('program').removeItemAt(x);

  for (var x = 0; x < programs.length; ++x)
    if (document.getElementById('extensions').selectedItem.value == programs[x].extension) {
      for (var y = 0; y < programs[x].programs.length; ++y)
        document.getElementById('program').appendItem(programs[x].programs[y].name, programs[x].programs[y].name);
      break;
    }
}
function loadProgramDetails() {
  if (!document.getElementById('program').selectedItem)
    return;

  for (var x = 0; x < programs.length; ++x)
    if (document.getElementById('extensions').selectedItem.value == programs[x].extension) {
      for (var y = 0; y < programs[x].programs.length; ++y)
        if (document.getElementById('program').selectedItem.value == programs[x].programs[y].name) {
          document.getElementById('name').disabled        = false;
          document.getElementById('executable').disabled  = false;
          document.getElementById('browse').disabled      = false;
          document.getElementById('arguments').disabled   = false;
          document.getElementById('apply').disabled       = false;
          document.getElementById('name').value           = programs[x].programs[y].name;
          document.getElementById('executable').value     = programs[x].programs[y].executable;
          document.getElementById('arguments').value      = programs[x].programs[y].arguments;
          break;
        }
      break;
    }
}
function addProgram() {
  if (!document.getElementById('extensions').selectedItem)
    return;

  document.getElementById('name').value           = "";
  document.getElementById('executable').value     = "";
  document.getElementById('arguments').value      = "";
  document.getElementById('name').disabled        = false;
  document.getElementById('executable').disabled  = false;
  document.getElementById('browse').disabled      = false;
  document.getElementById('arguments').disabled   = false;
  document.getElementById('apply').disabled       = false;
  document.getElementById('name').focus();
}
function removeProgram() {
  if (!document.getElementById('program').selectedItem)
    return;

  for (var x = 0; x < programs.length; ++x)
    if (document.getElementById('extensions').selectedItem.value == programs[x].extension) {
      for (var y = 0; y < programs[x].programs.length; ++y)
        if (document.getElementById('program').selectedItem.value == programs[x].programs[y].name) {
          programs[x].programs.splice(y, 1);
          break;
        }
      break;
    }

  var value = document.getElementById('program').selectedItem.value;
  document.getElementById('program').removeItemAt(
      document.getElementById('program').getIndexOfItem(document.getElementById('program').selectedItem));

  loadPrograms();
}
function apply() {
  if (document.getElementById('name').value == "" || document.getElementById('executable').value == "")
    return;

  var extIndex = 0;
  var inserted = false;
  var programDetails = { name       : document.getElementById('name').value,
                         executable : document.getElementById('executable').value,
                         arguments  : document.getElementById('arguments').value };

  for (var x = 0; x < programs.length; ++x)
    if (document.getElementById('extensions').selectedItem.value == programs[x].extension) {
      extIndex = x;
      for (var y = 0; y < programs[x].programs.length; ++y) {
        if (programs[x].programs[y].name == document.getElementById('name').value) {
          programs[x].programs[y] = programDetails;
          inserted = true;
          break;
        }
        if (programs[x].programs[y].name > document.getElementById('name').value) {
          programs[x].programs.splice(y, 0, programDetails);
          inserted = true;
          break;
        }
      }
      break;
    }

  if (!inserted)
    programs[extIndex].programs.push(programDetails);
  
  loadPrograms();
}
function browseLocal() {
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, strbundle.getString("selectFolder"), nsIFilePicker.modeOpen);
  fp.appendFilters(nsIFilePicker.filterApps | nsIFilePicker.filterAll);
  var res = fp.show();
  if (res == nsIFilePicker.returnOK)
    document.getElementById('executable').value = fp.file.path;
}
function savePrograms() {
  window.arguments[1].value = true;
  return true;
}
