function diff() {
  if (!isConnected)
    return;

  var missingRemoteFiles = new Array();
  var missingLocalFiles = new Array();
  var differentFiles = new Array();

  for (var x = 0; x < localTree.data.length; ++x) {
    var found = false;
    for (var y = 0; y < remoteTree.data.length; ++y)
      if (localTree.data[x].leafName == remoteTree.data[y].leafName) {
        found = true;
        if (localTree.data[x].fileSize != remoteTree.data[y].fileSize
            && !localTree.data[x].isDirectory() && !remoteTree.data[y].isDirectory) {
          differentFiles.push({ localFile: localTree.data[x], remoteFile: remoteTree.data[y],
                                reason: strbundle.getString("diffFileSize"), action: "nothing" });
          break;
        }
        if (localTree.data[x].isDirectory() != remoteTree.data[y].isDirectory) {
          differentFiles.push({ localFile: localTree.data[x], remoteFile: remoteTree.data[y],
                                reason: strbundle.getString("diffTypeMismatch"), action: "nothing" });
          break;
        }
        break;
      }
    if (!found)
      missingRemoteFiles.push({ file: localTree.data[x], action: "upload" });
  }

  for (var x = 0; x < remoteTree.data.length; ++x) {
    var found = false;
    for (var y = 0; y < localTree.data.length; ++y)
      if (localTree.data[y].leafName == remoteTree.data[x].leafName) {
        found = true;
        break;
      }
    if (!found)
      missingLocalFiles.push( { file: remoteTree.data[x], action: "download" });
  }

  if (missingLocalFiles.length == 0 && missingRemoteFiles.length == 0 && differentFiles.length == 0) {
    window.openDialog("chrome://fireftp/content/alert.xul","alert",
      "width=400,height=200,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", strbundle.getString("diffSame"));
    return;
  }

  var result = new Object();
  result.value = false;

  dialogOpen = true;
  window.openDialog("chrome://fireftp/content/diff.xul","diff",
    "width=400,height=400,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", missingLocalFiles, missingRemoteFiles, differentFiles, result);
  dialogOpen = false;

  if (result.value) {
    for (var x = 0; x < missingLocalFiles.length; ++x)
      if (missingLocalFiles[x].action != "nothing")
        transfer(missingLocalFiles[x].action == "download", missingLocalFiles[x].file);
    for (var x = 0; x < missingRemoteFiles.length; ++x)
      if (missingRemoteFiles[x].action != "nothing")
        transfer(missingRemoteFiles[x].action == "download", missingRemoteFiles[x].file);
    for (var x = 0; x < differentFiles.length; ++x)
      if (differentFiles[x].action != "nothing")
        transfer(differentFiles[x].action == "download",
                 differentFiles[x].action == "download" ? differentFiles[x].remoteFile : differentFiles[x].localFile);
  }
}
